#include <sys/types.h>
#include <sys/socket.h>
#include <sys/syslog.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "config.h"

int config_line = 0;	/* for error logging */
extern int o_syslog;

/*	do logging via syslog
*/

void m_syslog(str, p1, p2, p3, p4)
char *str,*p1,*p2,*p3,*p4;
{
#ifdef SYSLOG
	if (o_syslog) syslog(LOG_INFO, str, p1, p2, p3, p4);
#endif
}

/*	parse configuration file and execute something
*/

int parse(char config_file[255], char s_ias[16], char c_ias[16])
{

FILE *cfp;
char line[MAX_LINE_LEN];
char *cs_ias, *cc_ias, *execstr;

#ifdef DEBUG
printf ("Request from: %s for server %s\n", c_ias, s_ias);
#endif

#ifdef SYSLOG
openlog("mdd", (int)NULL, LOG_DAEMON);
#endif

if ( (cfp=fopen(config_file, "r")) == NULL ) {
#ifdef SYSLOG
	syslog(LOG_INFO, "can't open configuration file %s", config_file);
#else
	perror("can't open configuration file");
#endif
	exit(1);
}

while (fgets(line,MAX_LINE_LEN,cfp)!=NULL) {
	config_line++;
	if ((strlen(line)!=1) && (line[0]!='#') &&
		(cs_ias=(char *)strtok(line, ":")) &&
		(cc_ias=(char *)strtok((char *)0, ":")) &&
		(execstr=(char *)strtok((char *)0, ":\n")) ) {

#ifdef DEBUG
	printf ("s: %s c: %s exec: %s\n", cs_ias, cc_ias, execstr);
#endif

		if ( (chk_ias(cs_ias, strdup(s_ias))) && 
		     (chk_ias(cc_ias, strdup(c_ias))) ) {
			m_syslog("from %s for %s executed %s", c_ias, s_ias, execstr);
			(void) execl("/bin/sh", "sh", "-c", execstr, (char *) 0);
		}
	}
};

m_syslog("from %s for %s rejected", c_ias, s_ias);

close(cfp);

}; /* parse */

/*	chack addresses, do resolve
*/

int chk_ias(char *pattern, char *ias)
{

int i;
char *pnr[4],*nr[4];
struct hostent *hostinfo;
int go;
extern int h_errno;

#ifdef DEBUG
	printf ("pattern: %s request: %s\n",pattern,ias);
#endif

/*	if (strchr(pattern,'*')) return (TRUE);*/
	if ((pattern[0]=='*') && (pattern[1]==0)) return (TRUE);

	if ((hostinfo=gethostbyname(pattern)) != NULL )
		pattern = (char *)strdup(inet_ntoa(*(struct in_addr *)hostinfo->h_addr));

	go=TRUE;

	if (!(pnr[0]=(char *)strtok(pattern, "."))) {
		m_syslog("config error in line %d near %s", config_line, pattern);
		return(FALSE);
	}
	for (i=1; i<4; i++)
		if (!(pnr[i]=(char *)strtok((char *)0, "."))) {
			m_syslog("config error in line %d near %s", config_line, pnr[i-1]);
			return(FALSE);
		}

	if (!(nr[0]=(char *)strtok(ias, "."))) {
		m_syslog("config error in line %d near %s", config_line, ias);
		return(FALSE);
	}
	for (i=1; i<4; i++)
		if (!(nr[i]=(char *)strtok((char *)0, "."))) {
			m_syslog("config error in line %d near %s", config_line, nr[i-1]);
			return(FALSE);
		}

	for (i=0; i<4; i++) {
		if (strchr(pnr[i],'-')) go=(go && chk_range(pnr[i],nr[i]));
		else
			if ( (atoi(pnr[i])!=atoi(nr[i])) && 
			     (!strchr(pnr[i],'*')) ) go=FALSE;
/*
			if (atoi(pnr[i])!=atoi(nr[i])) go=FALSE;
*/
	}	

	return (go);

}

/*	check IP adressess ranges
*/

int chk_range(char *pnr, char *nr)
{
int numl,numh,num;
char *c;

	if (c=(char *)strtok(pnr, "-")) numl=atoi(c);
	else {
		m_syslog("config error in line %d near %s", config_line, pnr);
		return(FALSE);
	}

	if (c=(char *)strtok((char *)0, "- :\n")) numh=atoi(c);
	else {
		m_syslog("config error in line %d near %s", config_line, pnr);
		return(FALSE);
	}
	
	num=atoi(nr);

	if ((num>=numl) && (num<=numh)) return (TRUE);

return(FALSE);
}
